MopacGraphfReader
Date: 2019-10-22

org.jmol.adapter.readers.quantum

## Class MopacGraphfReader

- java.lang.Object
- - org.jmol.adapter.smarter.AtomSetCollectionReader
  - - org.jmol.adapter.readers.quantum.BasisFunctionReader
    - - org.jmol.adapter.readers.quantum.SlaterReader
      - - org.jmol.adapter.readers.quantum.MopacSlaterReader
        - - org.jmol.adapter.readers.quantum.MopacGraphfReader

- All Implemented Interfaces:
    javajs.api.GenericLineReader

      public class MopacGraphfReader
      extends MopacSlaterReader

  Reads Mopac 2007 GRAPHF output files
  Author:
    Bob Hanson

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.jmol.adapter.readers.quantum.SlaterReader

      `SlaterReader.OrbitalSorter, SlaterReader.SlaterSorter`

    - ### Nested classes/interfaces inherited from class org.jmol.adapter.readers.quantum.BasisFunctionReader

      `BasisFunctionReader.MOEnergySorter`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private int` | `ac`
    `private float[][]` | `invMatrix`
    `private boolean` | `isNewFormat`
    `private int` | `nCoefficients`
    `private javajs.util.Lst<float[]>` | `orbitalData`
    `private javajs.util.Lst<java.lang.String>` | `orbitalInfo`

    - ### Fields inherited from class org.jmol.adapter.readers.quantum.MopacSlaterReader

      `atomicNumbers, MIN_COEF`

    - ### Fields inherited from class org.jmol.adapter.readers.quantum.SlaterReader

      `slaterArray, slaters`

    - ### Fields inherited from class org.jmol.adapter.readers.quantum.BasisFunctionReader

      `alphaBeta, dfCoefMaps, ignoreMOs, moData, nCoef, nOrbitals, orbitalMaps, orbitals, shells`

    - ### Fields inherited from class org.jmol.adapter.smarter.AtomSetCollectionReader

      `addedData, addedDataKey, addVibrations, allowPDBFilter, ANGSTROMS_PER_BOHR, applySymmetryToBonds, asc, baseAtomIndex, binaryDoc, bsFilter, bsModels, calculationType, continuing, debugging, desiredModelNumber, desiredSpaceGroupIndex, desiredVibrationNumber, doApplySymmetry, doCentralize, doCheckUnitCell, doConvertToFractional, doPackUnitCell, doProcessLines, doReadMolecularOrbitals, dssr, fileName, fileOffset, filePath, fileScaling, fillRange, filter, filterHetero, fixJavaFloat, forcePacked, getHeader, haveAtomFilter, haveModel, havePartialChargeFilter, htParams, ignoreFileSpaceGroupName, ignoreFileSymmetryOperators, ignoreFileUnitCell, ignoreStructure, iHaveFractionalCoordinates, iHaveSymmetryOperators, iHaveUnitCell, isBinary, isConcatenated, isDSSP1, isFinalized, isMolecular, isPrimitive, isSequential, isTrajectory, latticeCells, latticeScaling, latticeType, line, lstNCS, matUnitCellOrientation, modDim, modelNumber, ms, mustFinalizeModelSet, next, out, packingError, prevline, primitiveToCrystal, ptLine, ptSupercell, reader, readerName, requiresBSFilter, reverseModels, rotateHexCell, sgName, stateScriptVersionInt, strSupercell, symmetry, templateAtomCount, thisBiomolecule, trajectorySteps, unitCellOffset, unitCellParams, useAltNames, useFileModelNumbers, validation, vibrationNumber, vibsFractional, vwr`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MopacGraphfReader()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected boolean` | `checkLine()`
    `protected void` | `initializeReader()`
    `private void` | `readAtoms()`
    `private boolean` | `readKeywords()`
    `private void` | `readMolecularOrbitals(boolean isBeta)`
    `private void` | `readSlaterBasis()`

    - ### Methods inherited from class org.jmol.adapter.readers.quantum.MopacSlaterReader

      `createSphericalSlaterByType, scaleSlater`

    - ### Methods inherited from class org.jmol.adapter.readers.quantum.SlaterReader

      `addSlater, addSlater, getSlaterConstCartesian, getSlaterConstDSpherical, setMOs, setSlaters, sortOrbitalCoefficients, sortOrbitals`

    - ### Methods inherited from class org.jmol.adapter.readers.quantum.BasisFunctionReader

      `canonicalizeQuantumSubshellTag, clearOrbitals, discardPreviousAtoms, enableShell, filterMO, fixSlaterTypes, getDfCoefMaps, getDFMap, getQuantumShellTag, getQuantumShellTagID, getQuantumShellTagIDSpherical, setMO`

    - ### Methods inherited from class org.jmol.adapter.smarter.AtomSetCollectionReader

      `addAtomXYZSymName, addExplicitLatticeVector, addJmolScript, addSites, addSiteScript, appendLoadNote, appendUunitCellInfo, applySymmetryAndSetTrajectory, applySymTrajASCR, checkCurrentLineForScript, checkFilterKey, checkLastModel, checkLineForScript, clearUnitCell, cloneLastAtomSet, discardLinesUntilBlank, discardLinesUntilContains, discardLinesUntilContains2, discardLinesUntilNonBlank, discardLinesUntilStartsWith, doGetModel, doGetVibration, doPreSymmetry, fill3x3, fillDataBlock, fillDataBlockFixed, fillFloatArray, fillFrequencyData, filterAtom, filterReject, finalizeMOData, finalizeModelSet, finalizeReaderASCR, finalizeSubclassReader, finalizeSubclassSymmetry, forceSymmetry, fractionalizeCoordinates, getElementSymbol, getFilter, getFortranFormatLengths, getInterface, getNewSymmetry, getStrings, getSymmetry, getTokens, getTokensFloat, initializeSymmetry, initializeSymmetryOptions, initializeTrajectoryFile, isLastModel, newAtomSet, parseFloat, parseFloatRange, parseFloatStr, parseInt, parseIntAt, parseIntRange, parseIntStr, parseToken, parseTokenNext, parseTokenRange, parseTokenStr, processBinaryDocument, processDOM, rd, read3Vectors, readDataObject, readLines, readNextLine, rejectAtomName, RL, set2D, setAtomCoord, setAtomCoordScaled, setAtomCoordTokens, setAtomCoordXYZ, setChainID, setElementAndIsotope, setFilter, setFilterAtomTypeStr, setFractionalCoordinates, setIsPDB, setLoadNote, setModelPDB, setSpaceGroupName, setSymmetryOperator, setTransform, setUnitCell, setUnitCellItem, setup, setupASCR`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### ac

          private int ac

    - #### nCoefficients

          private int nCoefficients

    - #### invMatrix

          private float[][] invMatrix

    - #### isNewFormat

          private boolean isNewFormat

    - #### orbitalData

          private javajs.util.Lst<float[]> orbitalData

    - #### orbitalInfo

          private javajs.util.Lst<java.lang.String> orbitalInfo

  - ### Constructor Detail

    - #### MopacGraphfReader

          public MopacGraphfReader()

  - ### Method Detail

    - #### initializeReader

          protected void initializeReader()

      Overrides:
        `initializeReader` in class `AtomSetCollectionReader`

    - #### checkLine

          protected boolean checkLine()
                               throws java.lang.Exception

      Overrides:
        `checkLine` in class `AtomSetCollectionReader`
      Returns:
        true if need to read new line
      Throws:
        `java.lang.Exception`

    - #### readAtoms

          private void readAtoms()
                          throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### readSlaterBasis

          private void readSlaterBasis()
                                throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### readMolecularOrbitals

          private void readMolecularOrbitals(boolean isBeta)
                                      throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### readKeywords

          private boolean readKeywords()
                                throws java.lang.Exception

      Throws:
        `java.lang.Exception`